*!*==============================================================================
*!*	  .
*!*	_pach="\data\spr\spr_izd.dbf"  ---    .
*!*	_alias=spr_izd                 ---   .( )
*!*	_mode=1                        ---   .
*!*	                                     1-shared;
*!*	                                     2-exclusive;
*!*                                      3-  (pach - )
*!*                                      4-  (pach - )
*!* open_tab(_pach,_mode)
*!*	 -
*!*	                   0 -------    ;
*!*	                   1 -------     exclusive;
*!*	                   2 -------     shared;
*!*                    3 -------    patch - 
*!*                                       (  3);
*!*                    4 -------    patch - 
*!*                                       (  4);
*!*					   5 -------   -  exclusive
*!*					   6 -------    ;
*!*						 . .
*!*	                               20.05.2003.
*!*								   21.05.2003.
*!*								   30.07.2003.
*!*==============================================================================
FUNCTION open_tab(_pach,_mode)
PRIVAT _alias,mode
_alias=substr(_pach,rat("\",_pach)+1,(rat(".",_pach)-rat("\",_pach)-1))
DO case
CASE _mode==1
	mode="shared"
CASE _mode==2
	mode="exclusive"
CASE _mode=3
	SELECT &_pach
	USE
	RETURN(3)
CASE _mode=4
	IF used(_alias)
		SELECT &_alias
		USE
	ENDIF
	RETURN(4)
ENDCASE
SELECT 0
IF !file(_pach)
	MESSAGEBOX("   -  "+_alias+".      - "+chr(13) + ;
		_pach+chr(13) + ;
		"        "+chr(13) + ;
		"  ",0)
	QUIT
ENDIF
IF used(_alias)
	PRIVAT gopa_kod
	SELE &_alias
	gopa_kod=iif(sys(2011)="Exclusive",1,2)
	RETURN(gopa_kod)
ELSE
	IF exclu_open(_pach,_mode)
		USE &_pach alias &_alias &mode
		RETURN(0)
	ELSE
		MESSAGEBOX("      "+ chr(13) + ;
			"   ",0," ")
		QUIT
	ENDIF
ENDIF
ENDFUN
*!*==============================================================================
*      EXCLUSIVE / SHARED
* :
* 		     tcFile -    
*			 _mode 	-  
* :
*			     
*			 .T. -  .F. - 
*  :
*		 If exclu_open(file_path,_mode)
* 		 USE (PathFile+"sklad.dbf") EXCLUSIVE
* 		 ELSE
* 			******
*  		 ENDIF
*                           25.07.03
*                            . .
*!*==============================================================================
FUNCTION exclu_open(file_path,_mode)
PRIVAT _file_path
_file_path=file_path
LOCAL lotvet, ndescfil, gopa
lotvet = .f.
DO case _mode
CASE _mode==1
	gopa=0
CASE _mode==2
	gopa=12
ENDCASE
ndescfil = fopen(_file_path,gopa)
IF ndescfil = -1
	lotvet = .f.
ELSE
	=fclose(ndescfil)
	lotvet = .t.
ENDIF
Release gopa
RETURN lotvet
ENDFUN
*===============================================================================
*   
FUNCTION reclock(nsec)
LOCAL wait_time
IF rlock()
	RETURN(.t.)
ENDIF
wait_time=nsec
WAIT window at 23,85 ",   !!!" nowait timeout(wait_time)
DO while (wait_time>0)
	IF rlock()
		RETURN(.t.)
	ENDIF
	INKEY(0.1)
	wait_time=wait_time-0.1
ENDDO
MESSAGEBOX("        !!!",0,"!!!")
RETURN(.f.)